//CN-Palm Summer 2003
//07/10/03 Added ?go 0 after good login
//10/10/03 Filled out CProcessLine() and added a MSG: handler
//         Your messages are sent to the screen too

#include "chat.h"

#define StrRight(dst, src, n) StrCopy(dst, src+n);
#define StrLeft(dst, src, n) StrCopy(dst, src); dst[n] = '\0'
static void StrSplit(Char *line, UInt8 pieces);
//#define WAddMessage(x, y) DAddMessage((y))

extern Char name[20];

//static Int16 myFreq = 8025;
static Char *typeLut[]=
{
	"SEND:PUB:",
	"SEND:PRIV",
	"SEND:FREQ:",
	"SEND:CHAT:",
	"SEND:MOD:",
	"SEND:CMD:",
	"SEND:PRIVCMD",
	"GO:",
	"\n"
};

static UInt8 clrLut[]=
{
	CLR_BLUE,
	CLR_GREEN,
	CLR_YELLOW,
	CLR_ORANGE,
	CLR_RED,
	CLR_GREEN,
	CLR_GREEN,
	CLR_GREEN,
	CLR_GREEN
};

static Char *part[5];

//// Receive ////

static void StrSplit(Char *line, UInt8 pieces)
{
	UInt8 i;
	part[0] = line;

	for(i=1; i<pieces && *line; line++)
	{
		if (*line == ':')
		{
			*line = '\0';
			line++;
			part[i] = line;
			i++;
		}
	}
}

void CProcessMsgLine(Char *line)
{
	Char str[256];
	line = line + 4;

	if (!StrNCompare(line, "ARENA:", 6))
	{
		WAddMessage(CLR_GREEN, line+6);
	}
	else if (!StrNCompare(line, "PUB:", 4))
	{
		StrSplit(line, 3);
		StrPrintF(str, "%s> %s", part[1], part[2]);
		WAddMessage(CLR_BLUE, str);
	}
	else if (!StrNCompare(line, "PRIV:", 5))
	{
		StrSplit(line, 3);
		StrPrintF(str, "%s> %s", part[1], part[2]);
		WAddMessage(CLR_GREEN, str);
	}
	else if (!StrNCompare(line, "FREQ:", 5))
	{
		StrSplit(line, 3);
		StrPrintF(str, "%s> %s", part[1], part[2]);
		WAddMessage(CLR_YELLOW, str);
	}
	else if (!StrNCompare(line, "CHAT:", 5))
	{
		StrSplit(line, 3);
		StrPrintF(str, "%s:%s", part[1], part[2]);
		WAddMessage(CLR_ORANGE, str);
	}
	else if (!StrNCompare(line, "MOD:", 4))
	{
		StrSplit(line, 3);
		StrPrintF(str, "%s> %s", part[1], part[2]);
		WAddMessage(CLR_RED, str);
	}
	else if (!StrNCompare(line, "SYSOP:", 6))
	{
		WAddMessage(CLR_RED, line+6);
	}
}

void CProcessLine(Char *line)
{
	Char str[256];
	if (!line) return;

	if (!StrNCompare(line, "LOGINBAD:", 9))
	{
		StrSplit(line, 2);
		StrPrintF(str, "Login failed: %s", part[1]);
		WAddMessage(CLR_GREEN, str);
		TCPDisconnect();
	}
	else if (!StrNCompare(line, "LOGINOK:", 8))
	{
		StrSplit(line, 2);
		StrPrintF(str, "Logged in as: %s", part[1]);
		WAddMessage(CLR_GREEN, str);
		CProcessInput("0", CT_ARENA);
	}
	else if (!StrNCompare(line, "INARENA:", 8))
	{
	}
	else if (!StrNCompare(line, "PLAYER:", 7))
	{
	}
	else if (!StrNCompare(line, "ENTERING:", 9))
	{
		StrSplit(line, 4);
		StrPrintF(str, "%s entered arena", part[1]);
		WAddMessage(CLR_GREEN, str);
	}
	else if (!StrNCompare(line, "LEAVING:", 8))
	{
		StrSplit(line, 4);
		StrPrintF(str, "%s left arena", part[1]);
		WAddMessage(CLR_GREEN, str);
	}
	else if (!StrNCompare(line, "SHIPFREQCHANGE:", 15))
	{
	}
	else if (!StrNCompare(line, "KILL:", 5))
	{
	}
	else if (!StrNCompare(line, "MSG:", 4))
	{
		CProcessMsgLine(line);
	}
	else
	{
		WAddMessage(CLR_GREEN, line);
	}

	MemPtrFree(line);
}

//// Send ////
void CSendLogin(Char *name, Char *passwd)
{
	Char buf[64];
	StrPrintF(buf, "LOGIN:%d:%s:%s\n", PROTOCOL, name, passwd);
	TCPSendRaw(buf, StrLen(buf));
}

void CProcessInput(Char *in, Int8 ct)
{
	Char buf[256];
	StrPrintF(buf, "%s%s\n", typeLut[ct], in);
	TCPSendRaw(buf, StrLen(buf));

	if (ct == CT_CMD || ct == CT_ARENA || ct == CT_RAW) return;
	StrPrintF(buf, "%s> %s", name, in);
	WAddMessage(clrLut[ct], buf);
}
